Index: trunk/sources/HeuristicLab.Problems.QuadraticAssignment.Algorithms/3.3/RandomizedRobustTabooSearch.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.QuadraticAssignment.Algorithms/3.3/RandomizedRobustTabooSearch.cs	(revision 6628)
+++ trunk/sources/HeuristicLab.Problems.QuadraticAssignment.Algorithms/3.3/RandomizedRobustTabooSearch.cs	(revision 6628)
@@ -0,0 +1,286 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.QuadraticAssignment.Algorithms {
+  [Item("Randomized Robust Taboo Search (QAP)", "This algorithm is based on Taillard, E. 1991. Robust Taboo Search for the Quadratic Assignment Problem. Parallel Computing 17, pp. 443-455.")]
+  [Creatable("Algorithms")]
+  [StorableClass]
+  public sealed class RandomizedRobustTabooSearchQAP : HeuristicOptimizationEngineAlgorithm, IStorableContent {
+    public string Filename { get; set; }
+
+    #region Problem Properties
+    public override Type ProblemType {
+      get { return typeof(QuadraticAssignmentProblem); }
+    }
+    public new QuadraticAssignmentProblem Problem {
+      get { return (QuadraticAssignmentProblem)base.Problem; }
+      set { base.Problem = value; }
+    }
+    #endregion
+
+    #region Parameter Properties
+    private FixedValueParameter<MultiAnalyzer> AnalyzerParameter {
+      get { return (FixedValueParameter<MultiAnalyzer>)Parameters["Analyzer"]; }
+    }
+    private FixedValueParameter<IntValue> SeedParameter {
+      get { return (FixedValueParameter<IntValue>)Parameters["Seed"]; }
+    }
+    private FixedValueParameter<BoolValue> SetSeedRandomlyParameter {
+      get { return (FixedValueParameter<BoolValue>)Parameters["SetSeedRandomly"]; }
+    }
+    private FixedValueParameter<IntValue> MaximumIterationsParameter {
+      get { return (FixedValueParameter<IntValue>)Parameters["MaximumIterations"]; }
+    }
+    private FixedValueParameter<IntValue> MinimumTabuTenureParameter {
+      get { return (FixedValueParameter<IntValue>)Parameters["MinimumTabuTenure"]; }
+    }
+    private FixedValueParameter<IntValue> MaximumTabuTenureParameter {
+      get { return (FixedValueParameter<IntValue>)Parameters["MaximumTabuTenure"]; }
+    }
+    private FixedValueParameter<IntValue> TabuTenureAdaptionIntervalParameter {
+      get { return (FixedValueParameter<IntValue>)Parameters["TabuTenureAdaptionInterval"]; }
+    }
+    #endregion
+
+    #region Properties
+    public int Seed {
+      get { return SeedParameter.Value.Value; }
+      set { SeedParameter.Value.Value = value; }
+    }
+    public bool SetSeedRandomly {
+      get { return SetSeedRandomlyParameter.Value.Value; }
+      set { SetSeedRandomlyParameter.Value.Value = value; }
+    }
+    public int MaximumIterations {
+      get { return MaximumIterationsParameter.Value.Value; }
+      set { MaximumIterationsParameter.Value.Value = value; }
+    }
+    public int MinimumTabuTenure {
+      get { return MinimumTabuTenureParameter.Value.Value; }
+      set { MinimumTabuTenureParameter.Value.Value = value; }
+    }
+    public int MaximumTabuTenure {
+      get { return MaximumTabuTenureParameter.Value.Value; }
+      set { MaximumTabuTenureParameter.Value.Value = value; }
+    }
+    public int TabuTenureAdaptionInterval {
+      get { return TabuTenureAdaptionIntervalParameter.Value.Value; }
+      set { TabuTenureAdaptionIntervalParameter.Value.Value = value; }
+    }
+    #endregion
+
+    [Storable]
+    private SolutionsCreator solutionsCreator;
+    [Storable]
+    private QAPRandomizedRobustTabooSeachOperator mainOperator;
+    [Storable]
+    private BestAverageWorstQualityAnalyzer qualityAnalyzer;
+
+    [StorableConstructor]
+    private RandomizedRobustTabooSearchQAP(bool deserializing) : base(deserializing) { }
+    private RandomizedRobustTabooSearchQAP(RandomizedRobustTabooSearchQAP original, Cloner cloner)
+      : base(original, cloner) {
+      solutionsCreator = cloner.Clone(original.solutionsCreator);
+      mainOperator = cloner.Clone(original.mainOperator);
+      qualityAnalyzer = cloner.Clone(original.qualityAnalyzer);
+    }
+    public RandomizedRobustTabooSearchQAP() {
+      Parameters.Add(new FixedValueParameter<MultiAnalyzer>("Analyzer", "The analyzers that are applied after each iteration.", new MultiAnalyzer()));
+      Parameters.Add(new FixedValueParameter<IntValue>("Seed", "The seed value of the random number generator.", new IntValue(0)));
+      Parameters.Add(new FixedValueParameter<BoolValue>("SetSeedRandomly", "True whether the seed should be set randomly for each run, false if it should be fixed.", new BoolValue(true)));
+      Parameters.Add(new FixedValueParameter<IntValue>("MaximumIterations", "The number of iterations that the algorithm should run.", new IntValue(10000)));
+      Parameters.Add(new FixedValueParameter<IntValue>("MinimumTabuTenure", "The minimum tabu tenure.", new IntValue(20)));
+      Parameters.Add(new FixedValueParameter<IntValue>("MaximumTabuTenure", "The maximum tabu tenure.", new IntValue(10)));
+      Parameters.Add(new FixedValueParameter<IntValue>("TabuTenureAdaptionInterval", "The amount of iterations that have to pass before the tabu tenure is adapted.", new IntValue(60)));
+
+      qualityAnalyzer = new BestAverageWorstQualityAnalyzer();
+      qualityAnalyzer.ResultsParameter.ActualName = "Results";
+      AnalyzerParameter.Value.Operators.Add(qualityAnalyzer);
+
+      RandomCreator randomCreator = new RandomCreator();
+      randomCreator.RandomParameter.ActualName = "Random";
+      randomCreator.SeedParameter.Value = null;
+      randomCreator.SeedParameter.ActualName = SeedParameter.Name;
+      randomCreator.SetSeedRandomlyParameter.Value = null;
+      randomCreator.SetSeedRandomlyParameter.ActualName = SetSeedRandomlyParameter.Name;
+
+      OperatorGraph.InitialOperator = randomCreator;
+
+      VariableCreator variableCreator = new VariableCreator();
+      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Iterations", new IntValue(0)));
+      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("TabuTenure", new IntValue(0)));
+      randomCreator.Successor = variableCreator;
+
+      ResultsCollector resultsCollector = new ResultsCollector();
+      resultsCollector.CollectedValues.Add(new LookupParameter<IntValue>("Iterations", "The actual iteration."));
+      resultsCollector.CollectedValues.Add(new LookupParameter<IntValue>("TabuTenure", "The actual tabu tenure."));
+      variableCreator.Successor = resultsCollector;
+
+      solutionsCreator = new SolutionsCreator();
+      solutionsCreator.NumberOfSolutions = new IntValue(1);
+      resultsCollector.Successor = solutionsCreator;
+
+      Placeholder analyzer = new Placeholder();
+      analyzer.Name = "(Analyzer)";
+      analyzer.OperatorParameter.ActualName = AnalyzerParameter.Name;
+      solutionsCreator.Successor = analyzer;
+
+      UniformSubScopesProcessor ussp = new UniformSubScopesProcessor();
+      analyzer.Successor = ussp;
+
+      mainOperator = new QAPRandomizedRobustTabooSeachOperator();
+      mainOperator.BestQualityParameter.ActualName = "BestSoFarQuality";
+      mainOperator.IterationsParameter.ActualName = "Iterations";
+      mainOperator.LongTermMemoryParameter.ActualName = "LongTermMemory";
+      mainOperator.MaximumIterationsParameter.ActualName = MaximumIterationsParameter.Name;
+      mainOperator.MaximumTabuTenureParameter.ActualName = MaximumTabuTenureParameter.Name;
+      mainOperator.MinimumTabuTenureParameter.ActualName = MinimumTabuTenureParameter.Name;
+      mainOperator.RandomParameter.ActualName = "Random";
+      mainOperator.ShortTermMemoryParameter.ActualName = "ShortTermMemory";
+      mainOperator.TabuTenureAdaptionIntervalParameter.ActualName = TabuTenureAdaptionIntervalParameter.Name;
+      mainOperator.TabuTenureParameter.ActualName = "TabuTenure";
+      mainOperator.ResultsParameter.ActualName = "Results";
+      ussp.Operator = mainOperator;
+
+      IntCounter iterationsCounter = new IntCounter();
+      iterationsCounter.ValueParameter.ActualName = "Iterations";
+      iterationsCounter.Increment = new IntValue(1);
+      ussp.Successor = iterationsCounter;
+
+      Comparator comparator = new Comparator();
+      comparator.Name = "Iterations < MaximumIterations ?";
+      comparator.LeftSideParameter.ActualName = "Iterations";
+      comparator.RightSideParameter.ActualName = MaximumIterationsParameter.Name;
+      comparator.Comparison = new Comparison(ComparisonType.Less);
+      comparator.ResultParameter.ActualName = "ContinueByIteration";
+      iterationsCounter.Successor = comparator;
+
+      ConditionalBranch branch = new ConditionalBranch();
+      branch.ConditionParameter.ActualName = "ContinueByIteration";
+      branch.TrueBranch = analyzer;
+      comparator.Successor = branch;
+
+      RegisterEventHandlers();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RandomizedRobustTabooSearchQAP(this, cloner);
+    }
+
+    protected override void OnProblemChanged() {
+      base.OnProblemChanged();
+      UpdateProblemSpecificParameters();
+      ParameterizeOperators();
+      UpdateAnalyzers();
+    }
+
+    protected override void Problem_EvaluatorChanged(object sender, EventArgs e) {
+      base.Problem_EvaluatorChanged(sender, e);
+      ParameterizeOperators();
+      Problem.Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
+    }
+
+    protected override void Problem_OperatorsChanged(object sender, EventArgs e) {
+      base.Problem_OperatorsChanged(sender, e);
+      UpdateAnalyzers();
+    }
+
+    protected override void Problem_Reset(object sender, EventArgs e) {
+      base.Problem_Reset(sender, e);
+      UpdateProblemSpecificParameters();
+      ParameterizeOperators();
+      UpdateAnalyzers();
+    }
+
+    private void Evaluator_QualityParameter_ActualNameChanged(object sender, EventArgs e) {
+      ParameterizeOperators();
+    }
+
+    private void RegisterEventHandlers() {
+      if (Problem != null) {
+        Problem.Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
+      }
+    }
+
+    public override void Start() {
+      if (ExecutionState == ExecutionState.Prepared) {
+        IntMatrix shortTermMemory = new IntMatrix(Problem.Weights.Rows, Problem.Weights.Rows);
+        DoubleMatrix shortTermMemory2 = new DoubleMatrix(Problem.Weights.Rows, Problem.Weights.Rows);
+        IntMatrix longTermMemory = new IntMatrix(Problem.Weights.Rows, Problem.Weights.Rows);
+        for (int i = 0; i < shortTermMemory.Rows; i++)
+          for (int j = 0; j < shortTermMemory.Rows; j++) {
+            shortTermMemory[i, j] = -1;
+            shortTermMemory2[i, j] = double.MinValue;
+            longTermMemory[i, j] = -1;
+          }
+
+        GlobalScope.Variables.Add(new Variable("ShortTermMemory", shortTermMemory));
+        GlobalScope.Variables.Add(new Variable("ShortTermMemory2", shortTermMemory2));
+        GlobalScope.Variables.Add(new Variable("LongTermMemory", longTermMemory));
+      }
+      base.Start();
+    }
+
+    private void UpdateProblemSpecificParameters() {
+      MinimumTabuTenure = (int)(0.9 * Problem.Weights.Rows);
+      MaximumTabuTenure = (int)(1.1 * Problem.Weights.Rows);
+      TabuTenureAdaptionInterval = 2 * MaximumTabuTenure;
+    }
+
+    private void UpdateAnalyzers() {
+      AnalyzerParameter.Value.Operators.Clear();
+      if (Problem != null) {
+        foreach (IAnalyzer analyzer in ((IProblem)Problem).Operators.OfType<IAnalyzer>())
+          if (!(analyzer is AlleleFrequencyAnalyzer<Permutation>) && !(analyzer is PopulationDiversityAnalyzer<Permutation>))
+            AnalyzerParameter.Value.Operators.Add(analyzer);
+      }
+      AnalyzerParameter.Value.Operators.Add(qualityAnalyzer);
+    }
+
+    private void ParameterizeOperators() {
+      if (Problem != null) {
+        solutionsCreator.SolutionCreatorParameter.ActualName = Problem.SolutionCreatorParameter.Name;
+        solutionsCreator.EvaluatorParameter.ActualName = Problem.EvaluatorParameter.Name;
+
+        qualityAnalyzer.QualityParameter.ActualName = Problem.Evaluator.QualityParameter.Name;
+
+        mainOperator.DistancesParameter.ActualName = Problem.DistancesParameter.Name;
+        mainOperator.PermutationParameter.ActualName = Problem.SolutionCreator.PermutationParameter.ActualName;
+        mainOperator.QualityParameter.ActualName = Problem.Evaluator.QualityParameter.ActualName;
+        mainOperator.WeightsParameter.ActualName = Problem.WeightsParameter.Name;
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.QuadraticAssignment.Algorithms/3.3/RobustTabooSeachOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.QuadraticAssignment.Algorithms/3.3/RobustTabooSeachOperator.cs	(revision 6628)
+++ trunk/sources/HeuristicLab.Problems.QuadraticAssignment.Algorithms/3.3/RobustTabooSeachOperator.cs	(revision 6628)
@@ -0,0 +1,206 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.QuadraticAssignment.Algorithms {
+  [Item("RobustTabooSearchOperator", "Performs an iteration of the robust taboo search algorithm as descrbied in Taillard 1991.")]
+  public sealed class RobustTabooSeachOperator : SingleSuccessorOperator, IIterationBasedOperator, IStochasticOperator {
+
+    #region Parameter Properties
+    public ILookupParameter<IntValue> IterationsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["Iterations"]; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ILookupParameter<Permutation> PermutationParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["Permutation"]; }
+    }
+    public ILookupParameter<DoubleMatrix> WeightsParameter {
+      get { return (ILookupParameter<DoubleMatrix>)Parameters["Weights"]; }
+    }
+    public ILookupParameter<DoubleMatrix> DistancesParameter {
+      get { return (ILookupParameter<DoubleMatrix>)Parameters["Distances"]; }
+    }
+    public ILookupParameter<IntMatrix> ShortTermMemoryParameter {
+      get { return (ILookupParameter<IntMatrix>)Parameters["ShortTermMemory"]; }
+    }
+    public ILookupParameter<DoubleMatrix> MoveQualityMatrixParameter {
+      get { return (ILookupParameter<DoubleMatrix>)Parameters["MoveQualityMatrix"]; }
+    }
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    public ILookupParameter<DoubleValue> BestQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["BestQuality"]; }
+    }
+    public ILookupParameter<Swap2Move> LastMoveParameter {
+      get { return (ILookupParameter<Swap2Move>)Parameters["LastMove"]; }
+    }
+    public ILookupParameter<BoolValue> UseNewTabuTenureAdaptionSchemeParameter {
+      get { return (ILookupParameter<BoolValue>)Parameters["UseNewTabuTenureAdaptionScheme"]; }
+    }
+    public ILookupParameter<ResultCollection> ResultsParameter {
+      get { return (ILookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+
+    public IValueLookupParameter<IntValue> MaximumIterationsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
+    }
+    public IValueLookupParameter<IntValue> MinimumTabuTenureParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["MinimumTabuTenure"]; }
+    }
+    public IValueLookupParameter<IntValue> MaximumTabuTenureParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumTabuTenure"]; }
+    }
+    public IValueLookupParameter<BoolValue> UseAlternativeAspirationParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["UseAlternativeAspiration"]; }
+    }
+    public IValueLookupParameter<IntValue> AlternativeAspirationTenureParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["AlternativeAspirationTenure"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private RobustTabooSeachOperator(bool deserializing) : base(deserializing) { }
+    private RobustTabooSeachOperator(RobustTabooSeachOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public RobustTabooSeachOperator() {
+      Parameters.Add(new LookupParameter<IntValue>("Iterations", "The current iteration."));
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
+      Parameters.Add(new LookupParameter<Permutation>("Permutation", "The permutation solution."));
+      Parameters.Add(new LookupParameter<DoubleMatrix>("Weights", "The weights matrix."));
+      Parameters.Add(new LookupParameter<DoubleMatrix>("Distances", "The distances matrix."));
+      Parameters.Add(new LookupParameter<IntMatrix>("ShortTermMemory", "The table that stores the iteration at which a certain facility has been assigned to a certain location."));
+      Parameters.Add(new LookupParameter<DoubleMatrix>("MoveQualityMatrix", "The quality of all swap moves as evaluated on the current permutation."));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value."));
+      Parameters.Add(new LookupParameter<DoubleValue>("BestQuality", "The best quality value."));
+      Parameters.Add(new LookupParameter<Swap2Move>("LastMove", "The last move that was applied."));
+      Parameters.Add(new LookupParameter<BoolValue>("UseNewTabuTenureAdaptionScheme", "True if the new tabu tenure adaption should be used or false otherwise."));
+      Parameters.Add(new LookupParameter<ResultCollection>("Results", "Collection that houses the results of the algorithm."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("MaximumIterations", "The number of iterations that the algorithm should run."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("MinimumTabuTenure", "The minimum tabu tenure."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("MaximumTabuTenure", "The maximum tabu tenure."));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("UseAlternativeAspiration", "True if the alternative aspiration condition should be used that takes moves that have not been made for some time above others."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("AlternativeAspirationTenure", "The time t that a move will be remembered for the alternative aspiration condition."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RobustTabooSeachOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      IRandom random = RandomParameter.ActualValue;
+      int iteration = IterationsParameter.ActualValue.Value;
+      IntMatrix shortTermMemory = ShortTermMemoryParameter.ActualValue;
+      DoubleMatrix weights = WeightsParameter.ActualValue;
+      DoubleMatrix distances = DistancesParameter.ActualValue;
+      DoubleMatrix moveQualityMatrix = MoveQualityMatrixParameter.ActualValue;
+
+      DoubleValue quality = QualityParameter.ActualValue;
+      DoubleValue bestQuality = BestQualityParameter.ActualValue;
+      if (bestQuality == null) {
+        BestQualityParameter.ActualValue = (DoubleValue)quality.Clone();
+        bestQuality = BestQualityParameter.ActualValue;
+      }
+
+      int minTenure = MinimumTabuTenureParameter.ActualValue.Value;
+      int maxTenure = MaximumTabuTenureParameter.ActualValue.Value;
+      int alternativeAspirationTenure = AlternativeAspirationTenureParameter.ActualValue.Value;
+      bool useAlternativeAspiration = UseAlternativeAspirationParameter.ActualValue.Value;
+      Permutation solution = PermutationParameter.ActualValue;
+      Swap2Move lastMove = LastMoveParameter.ActualValue;
+
+      double bestMoveQuality = double.MaxValue;
+      Swap2Move bestMove = null;
+      bool already_aspired = false;
+
+      foreach (Swap2Move move in ExhaustiveSwap2MoveGenerator.Generate(solution)) {
+        double moveQuality;
+        if (lastMove == null)
+          moveQuality = QAPSwap2MoveEvaluator.Apply(solution, move, weights, distances);
+        else moveQuality = QAPSwap2MoveEvaluator.Apply(solution, move, moveQualityMatrix[move.Index1, move.Index2], weights, distances, lastMove);
+
+        moveQualityMatrix[move.Index1, move.Index2] = moveQuality;
+        moveQualityMatrix[move.Index2, move.Index1] = moveQuality;
+
+        bool autorized = shortTermMemory[move.Index1, solution[move.Index2]] < iteration
+                      || shortTermMemory[move.Index2, solution[move.Index1]] < iteration;
+
+        bool aspired = (shortTermMemory[move.Index1, solution[move.Index2]] < iteration - alternativeAspirationTenure
+                     && shortTermMemory[move.Index2, solution[move.Index1]] < iteration - alternativeAspirationTenure)
+                  || quality.Value + moveQuality < bestQuality.Value;
+
+        if ((aspired && !already_aspired) // the first alternative move is aspired
+          || (aspired && already_aspired && moveQuality < bestMoveQuality) // an alternative move was already aspired, but this is better
+          || (autorized && !aspired && !already_aspired && moveQuality < bestMoveQuality)) { // a regular better move is found
+          bestMove = move;
+          bestMoveQuality = moveQuality;
+          if (aspired) already_aspired = true;
+        }
+      }
+
+      ResultCollection results = ResultsParameter.ActualValue;
+      if (results != null) {
+        IntValue aspiredMoves = null;
+        if (!results.ContainsKey("AspiredMoves")) {
+          aspiredMoves = new IntValue(already_aspired ? 1 : 0);
+          results.Add(new Result("AspiredMoves", "Counts the number of moves that were selected because of the aspiration criteria.", aspiredMoves));
+        } else if (already_aspired) {
+          aspiredMoves = (IntValue)results["AspiredMoves"].Value;
+          aspiredMoves.Value++;
+        }
+      }
+
+      LastMoveParameter.ActualValue = bestMove;
+
+      if (bestMove == null) return base.Apply();
+
+      bool useNewAdaptionScheme = UseNewTabuTenureAdaptionSchemeParameter.ActualValue.Value;
+      if (useNewAdaptionScheme) {
+        double r = random.NextDouble();
+        if (r == 0) r = 1; // transform to (0;1]
+        shortTermMemory[bestMove.Index1, solution[bestMove.Index1]] = (int)(iteration + r * r * r * maxTenure);
+        r = random.NextDouble();
+        if (r == 0) r = 1; // transform to (0;1]
+        shortTermMemory[bestMove.Index2, solution[bestMove.Index2]] = (int)(iteration + r * r * r * maxTenure);
+      } else {
+        shortTermMemory[bestMove.Index1, solution[bestMove.Index1]] = iteration + random.Next(minTenure, maxTenure);
+        shortTermMemory[bestMove.Index2, solution[bestMove.Index2]] = iteration + random.Next(minTenure, maxTenure);
+      }
+      Swap2Manipulator.Apply(solution, bestMove.Index1, bestMove.Index2);
+      quality.Value += bestMoveQuality;
+
+      if (quality.Value < bestQuality.Value) bestQuality.Value = quality.Value;
+
+      return base.Apply();
+    }
+  }
+}
